/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_support.S 191 2009-04-16 23:25:34Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼 ֥ARMѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "target_asm.inc"
#include "offset.h"

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥
 */
    .text
    .align 2
    .global hardware_init_hook
hardware_init_hook:
    mov   pc, lr

/*
 * ߥϥɥ
 */
    .text
    .align 2
    .global irq_handler
irq_handler:
    /*
     * IRQ⡼ɤǼ¹Ԥ
     */
    /*
     *  Υ⡼(ѡХ⡼)
     *  ܹԤƥȤ¸
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿IRQ⡼ɤ
     */
    msr   cpsr, #(CPSR_IRQ|CPSR_IRQ_BIT)
    sub   r0, lr, #4
    mrs   r1, spsr

    /*
     *  ߥϥɥ¹ԻΥ⡼ɡʥѡХ⡼ɡˤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT) 
    str   r0, [sp,#0x18] /* Ϥ򥹥å */
    stmfd sp!,{r1}       /* spsr򥹥å¸ */
    mov   lr, sp         /* λΥåΤ */

    /*
     *  ¿ųߤȽ
     */
    my_accb r2, r3              /* 㳰ߥͥȲ */
    ldr   r3, [r2, #ACCB_excpt_nest_count]
    add   r0, r3, #1            /* 㳰ߥͥȲ򹹿 */
    str   r0, [r2, #ACCB_excpt_nest_count]
    cmp   r3, #0    
    bne   irq_handler_1

    /* 
     * ܤ㳰ʳߡˤʤ饹åѹ
     */
    my_istkpt sp, r0

irq_handler_1:
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /*
     *  װȽꡥ
     */
    ldr   r0, =(DIC_CPUIF_IAR)
    ldr   r1, [r0]
    mov   r1, r1, asl #22  /* 9ӥåȰʳ򥯥ꥢ */
    mov   r1, r1, lsr #22

    /*
     *  ߥϥɥΥɥ쥹
     */
    my_inh_table r2, r3            /* ߥϥɥơ֥ɤ߹ */
    ldr   r0, [r2, r1, asl #2]     /* r0<-ߥϥɥ */

    /*
     *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
     *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
     *  ¸롥
     */
    ldr   lr, =(DIC_CPUIF_RII)
    ldr   r2, [lr]
    ldr   r3, =(DIC_CPUIF_PMR) /* ȯγͥ٥ޥ */
    ldr   lr, [r3]   
    str   r2, [r3]   /* ͥ٥ޥ򥻥åȤ */
    stmfd sp!, {lr}  /* ȯγͥ٥ޥ򥹥å¸ */

    stmfd sp!,{r1}       /* inhno ¸  */

    /* 
     * ߵ 
     */         
    msr   cpsr, #(CPSR_SVC|CPSR_ALWAYS_SET)

#ifdef LOG_INH_ENTER
    stmfd sp!,{r0}
    mov   r0, r1         /* inhno ѥ᡼    */
    bl    log_inh_enter  /* log_inh_enterƤӽФ */
    ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

    /* 
     * ߥϥɥθƤӽФ
     */        
    mov   lr,  pc
    mov   pc,  r0

target_ret_int:
    ldmfd sp!,{r0}       /* inhno   */

    ldr   r1,=DIC_CPUIF_EOI
    str   r0,[r1]                /* EOI쥸ؤν񤭹 */

#ifdef LOG_INH_LEAVE
    bl    log_inh_leave  /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET)

    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!,{r1}                       /* γͥ٥ޥ */
    ldr   r0, =(DIC_CPUIF_PMR)           /* DIC˥å */
    str   r1, [r0]

    /*
     * åݥ󥿤
     */
    ldmfd sp!,{r2}              /* Υåݥ󥿤 */
    mov   sp, r2
    
    /*
     * νARM¸Ǽ¹
     */
    b     ret_int

/*
 * åȰ¸㳰
 */
    .text
    .global target_exc_handler
target_exc_handler:
    /*
     *  㳰¹ԤΥ⡼ɡʥѡХ⡼ɡˤ
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT)
    str   r0, [sp,#0x18] /* Ϥ򥹥å */
    stmfd sp!,{r1}       /* spsr򥹥å¸ */
    mov   lr, sp         /* λΥåΤ */

    ldr   r0, =(DIC_CPUIF_PMR) /* 㳰ȯγͥ٥ޥ */
    ldr   r1, [r0]   
    stmfd sp!, {r1}  /* 㳰ȯγͥ٥ޥ򥹥å¸ */

    /* 
     * ƥȽΤᡤexcpt_nest_count 򥹥å¸
     * å¸ߤexcpt_nest_count-1ȼǤ뤬
     * åѤǤǥХåԤ䤹Τǡå
     * ¸롥
     */
    my_accb r0, r1
    ldr   r1, [r0, #ACCB_excpt_nest_count]
    stmfd sp!, {r1}

    mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

    /*
     *  ¿ųߤȽ
     */
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_exc_handler_1

    /* 
     * ܤμ¹Ԥʤ饹åѹ
     */
    my_istkpt sp, r0

target_exc_handler_1:
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /*
     *  locspnid¸
     */
    my_pcb r0, r1
    ldr    r1, [r0,#PCB_locspnid]
    stmfd  sp!,{r1}

    /* 
     * ȯγͥ٥ޥ򥹥å¸ 
     * ߥϥɥȽи롼ͭ뤿¸
     */
    ldr   r0, =(DIC_CPUIF_PMR) /* 㳰ȯγͥ٥ޥ */
    ldr   r1, [r0]   
    stmfd sp!, {r1}  /* 㳰ȯγͥ٥ޥ򥹥å¸ */

    /*
     *  CPU㳰ϥɥεưϤ
     */
    my_exch_table r0, r1       /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ                 */

    stmfd sp!,{r2}      /* excno ¸ */

    /* 
     * ߵ 
     * CPUå֡ߥå֤ϷѾ
     */         
    ldr   r0, [lr]
    and   r0, r0, #(CPSR_IRQ_BIT|CPSR_INTLOCK)
    orr   r0, r0, #(CPSR_SVC|CPSR_ALWAYS_SET)
    msr   cpsr,r0

#ifdef LOG_EXC_ENTER
    stmfd sp!,{r1, r3}
    mov   r0, r2         /* excno ѥ᡼    */
    bl    log_exc_enter  /* log_exc_enterƤӽФ */
    ldmfd sp!,{r1, r3}
#endif /* LOG_EXC_ENTER */

    /* 
     * CPU㳰ϥɥθƤӽФ
     *
     * 㳰ե졼ƬȤϤ
     */        
    mov   r0,  r3
    mov   lr,  pc
    mov   pc,  r1

target_ret_exc:
    ldmfd sp!,{r0}       /* excno   */
#ifdef LOG_EXC_LEAVE
    bl    log_exc_leave  /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */

    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET)

    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!,{r1}                       /* γͥ٥ޥ */
    ldr   r0, =(DIC_CPUIF_PMR)           /* DIC˥å */
    str   r1, [r0]

    /*
     * CPU㳰ȯlocspnidr0
     */
    ldmfd sp!,{r0} 

    /*
     * åݥ󥿤
     */
    ldmfd sp!,{r2}              /* Υåݥ󥿤 */
    mov   sp, r2
    
    /*
     * νARM¸Ǽ¹
     */
    b     ret_exc
