/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2008-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.c 249 2009-04-30 07:02:21Z ertl-honda $
 */

/*
 *  ץå¸⥸塼Nios2ѡ
 */
#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "nios2.h"

/*
 *  start.S ǤƱ
 */
volatile uint_t start_sync;

#ifndef NIOS2_USE_INT_VEC_INST
/*
 *  װȽΤΥӥåȥޥåץ̿
 */
const uint8_t int_bitmap_search_table[] = { 0, 1, 0, 2, 0, 1, 0,
										3, 0, 1, 0, 2, 0, 1, 0 };
#endif

/*
 *  ץå¸ν
 */
void
prc_initialize()
{
	/*
	 *  ͥ뵯ư󥿥ƥȤȤư뤿1
	 */ 
	my_npcb->except_nest_count = 1;

	/*
	 * Ƴߤγ׵ػߥե饰ػ
	 */
	my_npcb->idf = ~0U;

	/*
	 * ͥ٥ޥν
	 */ 
	my_npcb->iipm = 0U;

	/*
	 * Ƥγߤޥ
	 */
	set_ienable(~0U);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
	 */
	my_npcb->bitpat_cfgint = 0U;
}

/*
 *  ץå¸νλ
 */
void
prc_terminate(void)
{
	extern void    software_term_hook(void);
	void (*volatile fp)(void) = software_term_hook;

	/*
	 *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
	 *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
	 *  Ǥ롥
	 */
	if (fp != 0) {
		(*fp)();
	}

	start_sync = 0;

	/*
	 *  ٤Ƥγߤޥ롥
	 */
	set_ienable(~0U);
}

/*
 *  ׵饤°
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask)
{
	assert(VALID_INTNO(intno));
	assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	my_npcb->bitpat_cfgint |= INTNO_BITPAT(INTNO_MASK(intno));

	/* 
	 * äߤػߤ
	 */    
	x_disable_int(intno);

	if ((intatr & TA_ENAINT) != 0U){
		(void)x_enable_int(INTNO_MASK(intno));
	}
}

/*
 *  CPU㳰ȯΥ
 *
 *  CPU㳰ϥɥ椫顤CPU㳰ݥ󥿡p_excinfˤȤ
 *  ƸƤӽФȤǡCPU㳰ȯ򥷥ƥ˽Ϥ롥
 */
#ifdef SUPPORT_XLOG_SYS

void
xlog_sys(void *p_excinf)
{    
}

#endif /* SUPPORT_XLOG_SYS */

#ifndef OMIT_DEFAULT_EXC_HANDLER

/*
 * ̤㳰äν
 */
void
default_exc_handler(void *p_excinf){
	ID prc_id = ID_PRC(x_prc_index());

	syslog(LOG_EMERG, "Processor %d : Unregistered Exception occurs.", prc_id);
	syslog(LOG_EMERG, " Excno = %d.",
		   *(((uint32_t*)p_excinf) + CPUEXC_FLM_EXCNO));
	syslog(LOG_EMERG, " ESTATUS = 0x%x.",
		   *(((uint32_t*)p_excinf) + CPUEXC_FLM_ESTATUS));
	syslog(LOG_EMERG, " Addr = 0x%x.",
		   *(((uint32_t*)p_excinf) + CPUEXC_FLM_PC));
	syslog(LOG_EMERG, " IPM = 0x%x.",
			 *(((uint32_t*)p_excinf) + CPUEXC_FLM_IPM));
	syslog(LOG_EMERG, " Interrupt/Exception Nest Count = %d",
			 *(((uint32_t*)p_excinf) + CPUEXC_FLM_NEST));
	target_exit();
}

#endif /* OMIT_DEFAULT_EXC_HANDLER */

#ifndef OMIT_DEFAULT_INT_HANDLER

/*
 * ̤γߤäν
 */
void
default_int_handler(void *p_excinf){
	ID prc_id = ID_PRC(x_prc_index());

	syslog(LOG_EMERG, "Processor %d : Unregistered Interrupt occurs.", prc_id);
	syslog(LOG_EMERG, " Intno = %d.", *((int*)p_excinf));
	target_exit();
}

#endif /* OMIT_DEFAULT_INT_HANDLER */
