/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: alarm.c 235 2009-04-27 04:12:09Z ertl-honda $
 */

/*
 *		顼ϥɥ鵡ǽ
 */

#include "kernel_impl.h"
#include "check.h"
#include "alarm.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_ALM_ENTER
#define LOG_ALM_ENTER(p_almcb)
#endif /* LOG_ALM_ENTER */

#ifndef LOG_ALM_LEAVE
#define LOG_ALM_LEAVE(p_almcb)
#endif /* LOG_ALM_LEAVE */

#ifndef LOG_STA_ALM_ENTER
#define LOG_STA_ALM_ENTER(almid, almtim)
#endif /* LOG_STA_ALM_ENTER */

#ifndef LOG_STA_ALM_LEAVE
#define LOG_STA_ALM_LEAVE(ercd)
#endif /* LOG_STA_ALM_LEAVE */

#ifndef LOG_MSTA_ALM_ENTER
#define LOG_MSTA_ALM_ENTER(almid, almtim, prcid)
#endif /* LOG_STA_ALM_ENTER */

#ifndef LOG_MSTA_ALM_LEAVE
#define LOG_MSTA_ALM_LEAVE(ercd)
#endif /* LOG_STA_ALM_LEAVE */

#ifndef LOG_ALMMIG
#define LOG_ALMMIG(p_almcb, src_id, dest_id)
#endif /* LOG_ALMMIG */

#ifndef LOG_ISTA_ALM_ENTER
#define LOG_ISTA_ALM_ENTER(almid, almtim)
#endif /* LOG_ISTA_ALM_ENTER */

#ifndef LOG_ISTA_ALM_LEAVE
#define LOG_ISTA_ALM_LEAVE(ercd)
#endif /* LOG_ISTA_ALM_LEAVE */

#ifndef LOG_IMSTA_ALM_ENTER
#define LOG_IMSTA_ALM_ENTER(almid, almtim, prcid)
#endif /* LOG_ISTA_ALM_ENTER */

#ifndef LOG_IMSTA_ALM_LEAVE
#define LOG_IMSTA_ALM_LEAVE(ercd)
#endif /* LOG_ISTA_ALM_LEAVE */

#ifndef LOG_STP_ALM_ENTER
#define LOG_STP_ALM_ENTER(almid)
#endif /* LOG_STP_ALM_ENTER */

#ifndef LOG_STP_ALM_LEAVE
#define LOG_STP_ALM_LEAVE(ercd)
#endif /* LOG_STP_ALM_LEAVE */

#ifndef LOG_ISTP_ALM_ENTER
#define LOG_ISTP_ALM_ENTER(almid)
#endif /* LOG_ISTP_ALM_ENTER */

#ifndef LOG_ISTP_ALM_LEAVE
#define LOG_ISTP_ALM_LEAVE(ercd)
#endif /* LOG_ISTP_ALM_LEAVE */

#ifndef LOG_REF_ALM_ENTER
#define LOG_REF_ALM_ENTER(almid, pk_ralm)
#endif /* LOG_REF_ALM_ENTER */

#ifndef LOG_REF_ALM_LEAVE
#define LOG_REF_ALM_LEAVE(ercd, pk_ralm)
#endif /* LOG_REF_ALM_LEAVE */

/*
 *  顼ϥɥο
 */
#define tnum_alm	((uint_t)(tmax_almid - TMIN_ALMID + 1))

/*
 *  顼ϥɥID饢顼ϥɥ֥åФΥޥ
 */
#define INDEX_ALM(almid)	((uint_t)((almid) - TMIN_ALMID))
#define get_almcb(almid)	(p_almcb_table[INDEX_ALM(almid)])

/*
 *  顼ϥɥ鵡ǽν
 */
#ifdef TOPPERS_almini

void
initialize_alarm(void)
{
	uint_t	i;
	ALMCB	*p_almcb;

#ifdef TOPPERS_SYSTIM_GLOBAL
	if (!x_sense_mprc()) {
		return;
	}
#endif /* TOPPERS_SYSTIM_GLOBAL */

	for (i = 0; i < tnum_alm; i++) {
#ifdef TOPPERS_SYSTIM_LOCAL
		/* ˳դ줿顼ϥɥν */
		if(alminib_table[i].iaffinity == ID_PRC(x_prc_index())){
#endif /* TOPPERS_SYSTIM_LOCAL */
			p_almcb = p_almcb_table[i];
			p_almcb->p_alminib = &alminib_table[i];
			p_almcb->almsta = false;
			p_almcb->p_pcb = my_p_pcb;
#ifdef TOPPERS_SYSTIM_LOCAL
		}
#endif /* TOPPERS_SYSTIM_LOCAL */
	}
}

#endif /* TOPPERS_almini */

/*
 *  顼ϥɥư
 */
#ifdef TOPPERS_sta_alm

ER
sta_alm(ID almid, RELTIM almtim)
{
	ALMCB	*p_almcb;
	ER		ercd;

	LOG_STA_ALM_ENTER(almid, almtim);
	CHECK_TSKCTX_UNL();
	CHECK_ALMID(almid);
	CHECK_PAR(almtim <= TMAX_RELTIM);
	p_almcb = get_almcb(almid);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_almcb->p_pcb);
	if (p_almcb->almsta) {
		tmevtb_dequeue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb));
	}
	else {
		p_almcb->almsta = true;
	}
	tmevtb_enqueue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb), almtim,
								(CBACK) call_almhdr, (void *) p_almcb);
	ercd = E_OK;
	T_RELEASE_TSK_LOCK(p_almcb->p_pcb);

  error_exit:
	LOG_STA_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_sta_alm */

/*
 *  顼ϥɥư
 */
#ifdef TOPPERS_msta_alm

#ifdef TOPPERS_SYSTIM_LOCAL

ER
msta_alm(ID almid, RELTIM almtim, ID prcid)
{
	ALMCB	*p_almcb;
	ER		ercd;
	PCB		*t_p_pcb;
	PCB		*f_p_pcb;

	LOG_MSTA_ALM_ENTER(almid, almtim, prcid);
	CHECK_TSKCTX_UNL();
	CHECK_ALMID(almid);
	CHECK_PAR(almtim <= TMAX_RELTIM);
	CHECK_PRCID(prcid);
	p_almcb = get_almcb(almid);
	prcid = (prcid == TPRC_INIT)? p_almcb->p_alminib->iaffinity : prcid;
	CHECK_MIG(p_almcb->p_alminib->affinity_mask, prcid);
	/* ưΥץåPCB */
	t_p_pcb = mp_pcb(prcid);

  retry:
	T_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(p_almcb->p_pcb, t_p_pcb);
	/*
	 * åΤ¸
	 * å¸ȡå˥顼γդץå
	 * ѹǽ뤿ᡤå¸롥
	 */
	f_p_pcb = p_almcb->p_pcb;

	if (p_almcb->almsta) {
		tmevtb_dequeue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb));
	}
	else {
		p_almcb->almsta = true;
	}

	LOG_ALMMIG(p_almcb, f_p_pcb->prcid, prcid);
	/* ư pcb Ͽ */
	p_almcb->p_pcb = t_p_pcb;
	tmevtb_enqueue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb), almtim,
								(CBACK) call_almhdr, (void *) p_almcb);
	ercd = E_OK;
	T_RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb);

  error_exit:
	LOG_MSTA_ALM_LEAVE(ercd);
	return(ercd);
}

#else /* TOPPERS_SYSTIM_GLOBAL */

ER
msta_alm(ID almid, RELTIM almtim, ID prcid)
{
	ER		ercd = E_NOSPT;

	LOG_MSTA_ALM_ENTER(almid, almtim, prcid);
	LOG_MSTA_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_SYSTIM_GLOBAL */

#endif /* TOPPERS_msta_alm */

/*
 *  顼ϥɥưϡ󥿥ƥѡ
 */
#ifdef TOPPERS_ista_alm

ER
ista_alm(ID almid, RELTIM almtim)
{
	ALMCB	*p_almcb;
	ER		ercd;

	LOG_ISTA_ALM_ENTER(almid, almtim);
	CHECK_INTCTX_UNL();
	CHECK_ALMID(almid);
	CHECK_PAR(almtim <= TMAX_RELTIM);
	p_almcb = get_almcb(almid);

  retry:
	I_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_almcb->p_pcb);
	if (p_almcb->almsta) {
		tmevtb_dequeue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb));
	}
	else {
		p_almcb->almsta = true;
	}
	tmevtb_enqueue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb), almtim,
								(CBACK) call_almhdr, (void *) p_almcb);
	ercd = E_OK;
	I_RELEASE_TSK_LOCK(p_almcb->p_pcb);

  error_exit:
	LOG_ISTA_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_ista_alm */

/*
 *  顼ϥɥưϡ󥿥ƥѡ
 */
#ifdef TOPPERS_imsta_alm

#ifdef TOPPERS_SYSTIM_LOCAL

ER
imsta_alm(ID almid, RELTIM almtim, ID prcid)
{
	ALMCB	*p_almcb;
	ER		ercd;
	PCB		*t_p_pcb;
	PCB		*f_p_pcb;

	LOG_IMSTA_ALM_ENTER(almid, almtim, prcid);
	CHECK_INTCTX_UNL();
	CHECK_ALMID(almid);
	CHECK_PAR(almtim <= TMAX_RELTIM);
	p_almcb = get_almcb(almid);
	t_p_pcb = mp_pcb(prcid);

  retry:
	I_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(p_almcb->p_pcb, t_p_pcb);
	/* åΤ¸ */
	f_p_pcb = p_almcb->p_pcb;

	if (p_almcb->almsta) {
		tmevtb_dequeue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb));
	}
	else {
		p_almcb->almsta = true;
	}

	LOG_ALMMIG(p_almcb, f_p_pcb->prcid, prcid);
	/* ư pcb Ͽ */
	p_almcb->p_pcb = t_p_pcb;

	tmevtb_enqueue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb), almtim,
								(CBACK) call_almhdr, (void *) p_almcb);
	ercd = E_OK;
	I_RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb);

  error_exit:
	LOG_IMSTA_ALM_LEAVE(ercd);
	return(ercd);
}

#else /* TOPPERS_SYSTIM_GLOBAL */

ER
imsta_alm(ID almid, RELTIM almtim, ID prcid)
{
	ER		ercd = E_NOSPT;

	LOG_IMSTA_ALM_ENTER(almid, almtim, prcid);
	LOG_IMSTA_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_SYSTIM_GLOBAL */

#endif /* TOPPERS_imsta_alm */

/*
 *  顼ϥɥư
 */
#ifdef TOPPERS_stp_alm

ER
stp_alm(ID almid)
{
	ALMCB	*p_almcb;
	ER		ercd;

	LOG_STP_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();
	CHECK_ALMID(almid);
	p_almcb = get_almcb(almid);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_almcb->p_pcb);
	if (p_almcb->almsta) {
		p_almcb->almsta = false;
		tmevtb_dequeue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb));
	}
	ercd = E_OK;
	T_RELEASE_TSK_LOCK(p_almcb->p_pcb);

  error_exit:
	LOG_STP_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_stp_alm */

/*
 *  顼ϥɥưߡ󥿥ƥѡ
 */
#ifdef TOPPERS_istp_alm

ER
istp_alm(ID almid)
{
	ALMCB	*p_almcb;
	ER		ercd;

	LOG_ISTP_ALM_ENTER(almid);
	CHECK_INTCTX_UNL();
	CHECK_ALMID(almid);
	p_almcb = get_almcb(almid);

  retry:
	I_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_almcb->p_pcb);
	if (p_almcb->almsta) {
		p_almcb->almsta = false;
		tmevtb_dequeue(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb));
	}
	ercd = E_OK;
	I_RELEASE_TSK_LOCK(p_almcb->p_pcb);

  error_exit:
	LOG_ISTP_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_istp_alm */

/*
 *  顼ϥɥξֻ
 */
#ifdef TOPPERS_ref_alm

ER
ref_alm(ID almid, T_RALM *pk_ralm)
{
	ALMCB	*p_almcb;
	ER		ercd;

	LOG_REF_ALM_ENTER(almid, pk_ralm);
	CHECK_TSKCTX_UNL();
	CHECK_ALMID(almid);
	p_almcb = get_almcb(almid);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_almcb->p_pcb);
	if (p_almcb->almsta) {
		pk_ralm->almstat = TALM_STA;
		pk_ralm->lefttim = tmevt_lefttim(p_almcb->p_pcb->p_tevtcb, &(p_almcb->tmevtb));
	}
	else {
		pk_ralm->almstat = TALM_STP;
	}
	pk_ralm->prcid = p_almcb->p_pcb->prcid;
	ercd = E_OK;
	T_RELEASE_TSK_LOCK(p_almcb->p_pcb);

  error_exit:
	LOG_REF_ALM_LEAVE(ercd, pk_ralm);
	return(ercd);
}

#endif /* TOPPERS_ref_alm */

/*
 *  顼ϥɥ鵯ư롼
 */
#ifdef TOPPERS_almcal

void
call_almhdr(ALMCB *p_almcb)
{
	PRI		saved_ipm;

	/*
	 *  顼ϥɥ߾֤ˤ롥
	 */
	p_almcb->almsta = false;

	/*
	 *  顼ϥɥCPUå֤ǸƤӽФ
	 */
	saved_ipm = i_get_ipm();
	I_RELEASE_TSK_LOCK(p_almcb->p_pcb);

	LOG_ALM_ENTER(p_almcb);
	(*((ALMHDR)(p_almcb->p_alminib->almhdr)))(p_almcb->p_alminib->exinf);
	LOG_ALM_LEAVE(p_almcb);

  retry:
	if (!i_sense_lock()) {
		i_lock_cpu();
	}
	I_ACQUIRE_TSK_LOCK(p_almcb->p_pcb);

	i_set_ipm(saved_ipm);
	force_unlock_spin();
}

#endif /* TOPPERS_almcal */
