/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2008-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: mp.c 208 2009-04-20 15:20:22Z ertl-honda $
 */

/*
 *		ޥץå⥸塼
 */
#include "kernel_impl.h"
#include "mp.h"
#include "target_ipi.h"

#ifdef TOPPERS_mpini

#if TTYPE_KLOCK == G_KLOCK
/*
 *  㥤ȥå
 */
GLOCK giant_lock;
#endif /* TTYPE_KLOCK == G_KLOCK */

#ifndef OMIT_KER_REQ_ON_IPI
/*
 *  λ׵ե饰
 */
bool_t ext_ker_reqflg;
#endif /* OMIT_KER_REQ_ON_IPI */

/*
 *  ޥץå⥸塼ν
 */
void
initialize_pcb(void)
{
	uint_t	i;

	/*
	 *  PCB prcid 
	 */
	my_p_pcb->prcid = ID_PRC(x_prc_index());

#if TTYPE_KLOCK == G_KLOCK
	/*
	 *  㥤ȥåν
	 */
	x_initialize_giant_lock(&giant_lock);
#else /* TTYPE_KLOCK != G_KLOCK */
	/*
	 *  åν
	 */
	x_initialize_tsk_lock(&(my_p_pcb->tsk_lock));
#endif /* TTYPE_KLOCK != G_KLOCK */

#if TTYPE_KLOCK == P_KLOCK
	/*
	 *  ֥ȥåν
	 */
	x_initialize_obj_lock(&(my_p_pcb->obj_lock));
#endif /* TTYPE_KLOCK == P_KLOCK */

	/*
	 *  طν
	 */
	my_p_runtsk = my_p_schedtsk = NULL;
	my_reqflg = false;
	my_disdsp = false;
	my_dspflg = true;

	for (i = 0; i < TNUM_TPRI; i++) {
		queue_initialize(&(my_ready_queue[i]));
	}

	my_ready_primap = 0U;

	my_locspnid = 0U;

#ifndef OMIT_KER_REQ_ON_IPI
	if (x_sense_mprc()) {
		ext_ker_reqflg = false;
	}
#endif /*  OMIT_KER_REQ_ON_IPI */
}

#endif /* TOPPERS_mpini */

#ifdef TOPPERS_ipi_handler

/*
 *  ץåֳߥϥɥ
 */
void
ipi_handler(void)
{
	target_ipi_clear();

#ifndef OMIT_KER_REQ_ON_IPI
	/*
	 *  λ׵å
	 */
	if (ext_ker_reqflg) {
		ext_ker();
	}
#endif /* OMIT_KER_REQ_ON_IPI */

	my_reqflg = true;
}

#endif /* TOPPERS_ipi_handler */

#ifdef TOPPERS_disp_req

/*
 *  ǥѥå׵
 *  оݤ¾ץåξϥץåֳߤȯԤ
 */
bool_t
dispatch_request(PCB* p_pcb)
{
	if (p_pcb == my_p_pcb) {
		return true;
	}
	else {
		target_ipi_raise(p_pcb->prcid);
		return false;
	}
}

#endif /* TOPPERS_disp_req */

#ifdef TOPPERS_ext_ker_req

#ifndef OMIT_KER_REQ_ON_IPI

/*
 *  λ׵
 */
void
ext_ker_request(void)
{
	ID prcid;

	/* Ǥ׵᤬ФƤХ꥿ */
	if (ext_ker_reqflg) {
		return;
	}

	ext_ker_reqflg = true;

	for(prcid = 1; prcid <= TNUM_PRC; prcid++){
		if (prcid != ID_PRC(x_prc_index())) {
			target_ipi_raise(prcid);
		}
	}
}

#endif /* OMIT_KER_REQ_ON_IPI */

#ifndef OMIT_BARRIER_SYNC

/*
 *  ХꥢƱѿ
 */
static volatile uint_t prc_init[TNUM_PRC];
static volatile uint_t sys_start;

/*
 *  ХꥢƱ
 */
void
barrier_sync(uint_t phase)
{
	uint_t i, j;
	uint_t flag;

	prc_init[x_prc_index()] = phase;

	if (x_sense_mprc()) {
		do{
			flag = 0;
			for(i = 0; i < TNUM_PRC; i++){
				if(prc_init[i] == phase){
					flag++;
				}
			}
			for(j = 0; j < 100; j++);
		}while (flag < TNUM_PRC);
		sys_start = phase;
	}
	else {
		while(sys_start != phase) {
			for(j = 0; j < 100; j++);
		}
	}
}

#endif  /* OMIT_BARRIER_SYNC */

#endif /* TOPPERS_ext_ker_req */
