/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: spin_lock.c 190 2009-04-15 13:35:23Z ertl-honda $
 */

/*
 *		ԥåǽ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "spin_lock.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_LOC_SPN_ENTER
#define LOG_LOC_SPN_ENTER(spnid)
#endif  /* LOG_LOC_SPN_ENTER */

#ifndef LOG_LOC_SPN_LEAVE
#define LOG_LOC_SPN_LEAVE(ercd)
#endif  /* LOG_LOC_SPN_LEAVE */

#ifndef LOG_ILOC_SPN_ENTER
#define LOG_ILOC_SPN_ENTER(spnid)
#endif  /* LOG_ILOC_SPN_ENTER */

#ifndef LOG_ILOC_SPN_LEAVE
#define LOG_ILOC_SPN_LEAVE(ercd)
#endif  /* LOG_ILOC_SPN_LEAVE */

#ifndef LOG_TRY_SPN_ENTER
#define LOG_TRY_SPN_ENTER(spnid)
#endif  /* LOG_TRY_SPN_ENTER */

#ifndef LOG_TRY_SPN_LEAVE
#define LOG_TRY_SPN_LEAVE(ercd)
#endif  /* LOG_TRY_SPN_LEAVE */

#ifndef LOG_ITRY_SPN_ENTER
#define LOG_ITRY_SPN_ENTER(spnid)
#endif  /* LOG_ITRY_SPN_ENTER */

#ifndef LOG_ITRY_SPN_LEAVE
#define LOG_ITRY_SPN_LEAVE(ercd)
#endif  /* LOG_ITRY_SPN_LEAVE */

#ifndef LOG_UNL_SPN_ENTER
#define LOG_UNL_SPN_ENTER(spnid)
#endif  /* LOG_UNL_SPN_ENTER */

#ifndef LOG_UNL_SPN_LEAVE
#define LOG_UNL_SPN_LEAVE(ercd)
#endif  /* LOG_UNL_SPN_LEAVE */

#ifndef LOG_IUNL_SPN_ENTER
#define LOG_IUNL_SPN_ENTER(spnid)
#endif  /* LOG_IUNL_SPN_ENTER */

#ifndef LOG_IUNL_SPN_LEAVE
#define LOG_IUNL_SPN_LEAVE(ercd)
#endif  /* LOG_IUNL_SPN_LEAVE */

#ifndef LOG_REF_SPN_ENTER
#define LOG_REF_SPN_ENTER(spnid, pk_rspn)
#endif  /* LOG_REF_SPN_ENTER */

#ifndef LOG_REF_SPN_LEAVE
#define LOG_REF_SPN_LEAVE(ercd, pk_rspn)
#endif  /* LOG_REF_SPN_LEAVE */

/*
 *  ԥåο
 */
#define tnum_spn		((uint_t)(tmax_spnid - TMIN_SPNID + 1))
#define INDEX_SPN(spnid)	((uint_t)((spnid) - TMIN_SPNID))
#define get_spncb(spnid)	(p_spncb_table[INDEX_SPN(spnid)])

#if TTYPE_SPN == NATIVE_SPN

/*
 *  ͥƥ
 */

/*
 *  ԥåǽν
 */
#ifdef TOPPERS_spnini

void
initialize_spin_lock(void)
{
	uint_t	i;
	SPNCB	*p_spncb;

	my_locspnid = 0;

	if (x_sense_mprc()) {
		for (i = 0; i < tnum_spn;  i++) {
			p_spncb = p_spncb_table[i];
			p_spncb->p_spninib = &(spninib_table[i]);
			x_initialize_spin((i + 1), &(p_spncb->spn_lock));
		}
	}
}

#endif /* TOPPERS_spnini */

/*
 *  ԥåζmy_locspnidоݤˤ
 */
#ifdef TOPPERS_force_unlock_spin

void
force_unlock_spin(void)
{
	SPNCB   *p_spncb;

	if (my_locspnid != 0U) {
		p_spncb = get_spncb(my_locspnid);
		i_unlock_spin(&(p_spncb->spn_lock));
		my_locspnid = 0;
	}
}

#endif /* TOPPERS_force_unlock_spin */

/*
 *  ԥåμ
 */
#ifdef TOPPERS_loc_spn

ER
loc_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_LOC_SPN_ENTER(spnid);
	CHECK_TSKCTX_UNL();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

  retry:
	t_lock_cpu();
	if (my_locspnid == 0) {
		if (t_lock_spin(&(p_spncb->spn_lock))) {
			t_unlock_cpu();
			goto retry;
		}
		my_locspnid = spnid;
		ercd = E_OK;
	}
	else {
		/* Ǥ˥åƤ */
		ercd = E_CTX;
	}

  error_exit:
	LOG_LOC_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_loc_spn */

/*
 *  ԥåμ󥿥ƥѡ
 */
#ifdef TOPPERS_iloc_spn

ER
iloc_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_ILOC_SPN_ENTER(spnid);
	CHECK_INTCTX_UNL();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

  retry:
	i_lock_cpu();
	if (my_locspnid == 0) {
		if (i_lock_spin(&(p_spncb->spn_lock))) {
			i_unlock_cpu();
			goto retry;
		}
		my_locspnid = spnid;
		ercd = E_OK;
	}
	else {
		/* Ǥ˥åƤ */
		ercd = E_CTX;
	}

  error_exit:
	LOG_ILOC_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_iloc_spn */

/*
 *  ԥåμʥݡ󥰡
 */
#ifdef TOPPERS_try_spn

ER
try_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_TRY_SPN_ENTER(spnid);
	CHECK_TSKCTX_UNL();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

	t_lock_cpu();
	if (my_locspnid == 0) {
		if (t_try_lock_spin(&(p_spncb->spn_lock))) {
			t_unlock_cpu();
			ercd = E_OBJ;
		}
		else {
			my_locspnid = spnid;
			ercd = E_OK;
		}
	}
	else {
		/* Ǥ˥åƤ */
		ercd = E_CTX;
	}

  error_exit:
	LOG_TRY_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_try_spn */

/*
 *  ԥåμʥݡ, 󥿥ƥѡ
 */
#ifdef TOPPERS_itry_spn

ER
itry_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_ITRY_SPN_ENTER(spnid);
	CHECK_INTCTX_UNL();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

	i_lock_cpu();
	if (my_locspnid == 0) {
		if (i_try_lock_spin(&(p_spncb->spn_lock))) {
			i_unlock_cpu();
			ercd = E_TMOUT;
		}
		else {
			my_locspnid = spnid;
			ercd = E_OK;
		}
	}
	else {
		/* Ǥ˥åƤ */
		ercd = E_CTX;
	}

  error_exit:
	LOG_ITRY_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_itry_spn */

/*
 *  ԥåβ
 */
#ifdef TOPPERS_unl_spn

ER
unl_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_UNL_SPN_ENTER(spnid);
	CHECK_TSKCTX();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

	if (my_locspnid != spnid) {
		ercd = E_CTX;
	}
	else {
		t_unlock_spin(&(p_spncb->spn_lock));
		my_locspnid = 0;
		t_unlock_cpu();
		ercd = E_OK;
	}

  error_exit:
	LOG_UNL_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_unl_spn */

/*
 *  ԥåβ󥿥ƥѡ
 */
#ifdef TOPPERS_iunl_spn

ER
iunl_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_IUNL_SPN_ENTER(spnid);
	CHECK_INTCTX();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

	if (my_locspnid != spnid) {
		ercd = E_CTX;
	}
	else {
		i_unlock_spin(&(p_spncb->spn_lock));
		my_locspnid = 0;
		i_unlock_cpu();
		ercd = E_OK;
	}

  error_exit:
	LOG_IUNL_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_iunl_spn */

#else /* TTYPE_SPN == EMULATE_SPN */

/*
 *  ߥ졼
 */

/*
 *  ԥåǽν
 */
#ifdef TOPPERS_spnini

void
initialize_spin_lock(void)
{
	uint_t	i;
	SPNCB	*p_spncb;

	my_locspnid = 0;

	if (x_sense_mprc()) {
		for (i = 0; i < tnum_spn;  i++) {
			p_spncb = p_spncb_table[i];
			p_spncb->lock_flg = false;
			p_spncb->p_spninib = &(spninib_table[i]);
		}
	}
}

#endif /* TOPPERS_spnini */

/*
 *  ԥåζmy_locspnidоݤˤ
 */
#ifdef TOPPERS_force_unlock_spin

void
force_unlock_spin(void)
{
	SPNCB   *p_spncb;

	if (my_locspnid != 0U) {
		p_spncb = get_spncb(my_locspnid);
		p_spncb->lock_flg = false;
		my_locspnid = 0;
	}
}

#endif /* TOPPERS_force_unlock_spin */

/*
 *  ԥåμ
 */
#ifdef TOPPERS_loc_spn

ER
loc_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_LOC_SPN_ENTER(spnid);
	CHECK_TSKCTX_UNL();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_spncb);
	if (my_locspnid == 0) {
		if (p_spncb->lock_flg) {
			/* Ǥ˥åƤ */
			T_RELEASE_OBJ_LOCK(p_spncb);
			goto retry;
		}
		else {
			/* åƤʤä */
			p_spncb->lock_flg = true;
			my_locspnid = spnid;
			RELEASE_OBJ_LOCK(p_spncb);
		}
		ercd = E_OK;
	}
	else {
		/* Ǥ˥åƤ */
		ercd = E_CTX;
	}

  error_exit:
	LOG_LOC_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_loc_spn */

/*
 *  ԥåμ󥿥ƥѡ
 */
#ifdef TOPPERS_iloc_spn

ER
iloc_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_ILOC_SPN_ENTER(spnid);
	CHECK_INTCTX_UNL();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

  retry:
	I_ACQUIRE_OBJ_LOCK(p_spncb);
	if (my_locspnid == 0) {
		if (p_spncb->lock_flg) {
			/* Ǥ˥åƤ */
			I_RELEASE_OBJ_LOCK(p_spncb);
			goto retry;
		}
		else {
			/* åƤʤä */
			p_spncb->lock_flg = true;
			my_locspnid = spnid;
			RELEASE_OBJ_LOCK(p_spncb);
		}
		ercd = E_OK;
	}
	else {
		/* Ǥ˥åƤ */
		ercd = E_CTX;
	}

  error_exit:
	LOG_ILOC_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_iloc_spn */

/*
 *  ԥåμʥݡ󥰡
 */
#ifdef TOPPERS_try_spn

ER
try_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_TRY_SPN_ENTER(spnid);
	CHECK_TSKCTX_UNL();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_spncb);
	if (my_locspnid == 0) {
		if (p_spncb->lock_flg) {
			/* Ǥ˥åƤ */
			ercd = E_TMOUT;
			T_RELEASE_OBJ_LOCK(p_spncb);
		}
		else {
			/* åƤʤä */
			p_spncb->lock_flg = true;
			my_locspnid = spnid;
			ercd = E_OK;
			RELEASE_OBJ_LOCK(p_spncb);
		}
	}
	else {
		/* Ǥ˥åƤ */
		ercd = E_CTX;
	}

  error_exit:
	LOG_TRY_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_try_spn */

/*
 *  ԥåμʥݡ, 󥿥ƥѡ
 */
#ifdef TOPPERS_itry_spn


ER
itry_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_ITRY_SPN_ENTER(spnid);
	CHECK_INTCTX_UNL();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

  retry:
	I_ACQUIRE_OBJ_LOCK(p_spncb);
	if (my_locspnid == 0) {
		if (p_spncb->lock_flg) {
			/* Ǥ˥åƤ */
			ercd = E_TMOUT;
			I_RELEASE_OBJ_LOCK(p_spncb);
		}
		else {
			/* åƤʤä */
			p_spncb->lock_flg = true;
			my_locspnid = spnid;
			ercd = E_OK;
			RELEASE_OBJ_LOCK(p_spncb);
		}
	}
	else {
		/* Ǥ˥åƤ */
		ercd = E_CTX;
	}

  error_exit:
	LOG_ITRY_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_itry_spn */

/*
 *  ԥåβ
 */
#ifdef TOPPERS_unl_spn

ER
unl_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_UNL_SPN_ENTER(spnid);
	CHECK_TSKCTX();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

	if (my_locspnid != spnid) {
		ercd = E_CTX;
	}
	else {
		ACQUIRE_OBJ_LOCK(p_spncb);
		p_spncb->lock_flg = false;
		my_locspnid = 0;
		ercd = E_OK;
		T_RELEASE_OBJ_LOCK(p_spncb);
	}

  error_exit:
	LOG_UNL_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_unl_spn */

/*
 *  ԥåβ󥿥ƥѡ
 */
#ifdef TOPPERS_iunl_spn

ER
iunl_spn(ID spnid)
{
	ER		ercd;
	SPNCB   *p_spncb;

	LOG_UNL_SPN_ENTER(spnid);
	CHECK_INTCTX();
	CHECK_SPNID(spnid);
	p_spncb = get_spncb(spnid);

	if (my_locspnid != spnid) {
		ercd = E_CTX;
	}
	else {
		ACQUIRE_OBJ_LOCK(p_spncb);
		p_spncb->lock_flg = false;
		my_locspnid = 0;
		ercd = E_OK;
		I_RELEASE_OBJ_LOCK(p_spncb);
	}

  error_exit:
	LOG_UNL_SPN_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_iunl_spn */

#endif /* TTYPE_SPN == EMULATE_SPN */

/*
 *  ԥåξֻ
 */
#ifdef TOPPERS_ref_spn

ER
ref_spn(ID spnid, T_RSPN *pk_rspn)
{
	ER		ercd;

	LOG_REF_SPN_ENTER(spnid, pk_rspn);
	CHECK_TSKCTX()
	CHECK_SPNID(spnid);

	pk_rspn->spnstat = (spnid == my_locspnid) ? TSPN_LOC : TSPN_UNL;
	ercd = E_OK;

  error_exit:
	LOG_REF_SPN_LEAVE(ercd, pk_rspn);
	return(ercd);
}

#endif /* TOPPERS_ref_spn */
