/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: task_sync.c 254 2009-05-07 04:18:08Z ertl-honda $
 */

/*
 *		°Ʊǽ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mp.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_SLP_TSK_ENTER
#define LOG_SLP_TSK_ENTER()
#endif /* LOG_SLP_TSK_ENTER */

#ifndef LOG_SLP_TSK_LEAVE
#define LOG_SLP_TSK_LEAVE(ercd)
#endif /* LOG_SLP_TSK_LEAVE */

#ifndef LOG_TSLP_TSK_ENTER
#define LOG_TSLP_TSK_ENTER(tmout)
#endif /* LOG_TSLP_TSK_ENTER */

#ifndef LOG_TSLP_TSK_LEAVE
#define LOG_TSLP_TSK_LEAVE(ercd)
#endif /* LOG_TSLP_TSK_LEAVE */

#ifndef LOG_WUP_TSK_ENTER
#define LOG_WUP_TSK_ENTER(tskid)
#endif /* LOG_WUP_TSK_ENTER */

#ifndef LOG_WUP_TSK_LEAVE
#define LOG_WUP_TSK_LEAVE(ercd)
#endif /* LOG_WUP_TSK_LEAVE */

#ifndef LOG_IWUP_TSK_ENTER
#define LOG_IWUP_TSK_ENTER(tskid)
#endif /* LOG_IWUP_TSK_ENTER */

#ifndef LOG_IWUP_TSK_LEAVE
#define LOG_IWUP_TSK_LEAVE(ercd)
#endif /* LOG_IWUP_TSK_LEAVE */

#ifndef LOG_CAN_WUP_ENTER
#define LOG_CAN_WUP_ENTER(tskid)
#endif /* LOG_CAN_WUP_ENTER */

#ifndef LOG_CAN_WUP_LEAVE
#define LOG_CAN_WUP_LEAVE(ercd)
#endif /* LOG_CAN_WUP_LEAVE */

#ifndef LOG_REL_WAI_ENTER
#define LOG_REL_WAI_ENTER(tskid)
#endif /* LOG_REL_WAI_ENTER */

#ifndef LOG_REL_WAI_LEAVE
#define LOG_REL_WAI_LEAVE(ercd)
#endif /* LOG_REL_WAI_LEAVE */

#ifndef LOG_IREL_WAI_ENTER
#define LOG_IREL_WAI_ENTER(tskid)
#endif /* LOG_IREL_WAI_ENTER */

#ifndef LOG_IREL_WAI_LEAVE
#define LOG_IREL_WAI_LEAVE(ercd)
#endif /* LOG_IREL_WAI_LEAVE */

#ifndef LOG_SUS_TSK_ENTER
#define LOG_SUS_TSK_ENTER(tskid)
#endif /* LOG_SUS_TSK_ENTER */

#ifndef LOG_SUS_TSK_LEAVE
#define LOG_SUS_TSK_LEAVE(ercd)
#endif /* LOG_SUS_TSK_LEAVE */

#ifndef LOG_RSM_TSK_ENTER
#define LOG_RSM_TSK_ENTER(tskid)
#endif /* LOG_RSM_TSK_ENTER */

#ifndef LOG_RSM_TSK_LEAVE
#define LOG_RSM_TSK_LEAVE(ercd)
#endif /* LOG_RSM_TSK_LEAVE */

#ifndef LOG_DLY_TSK_ENTER
#define LOG_DLY_TSK_ENTER(dlytim)
#endif /* LOG_DLY_TSK_ENTER */

#ifndef LOG_DLY_TSK_LEAVE
#define LOG_DLY_TSK_LEAVE(ercd)
#endif /* LOG_DLY_TSK_LEAVE */

/*
 *  Ԥ
 */
#ifdef TOPPERS_slp_tsk

ER
slp_tsk(void)
{
	ER		ercd;

	LOG_SLP_TSK_ENTER();
	CHECK_DISPATCH();

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_RUNNABLE();
	if (my_p_runtsk->wupque) {
		my_p_runtsk->wupque = false;
		RELEASE_TSK_LOCK(my_p_pcb);
		ercd = E_OK;
	}
	else {
		my_p_runtsk->tstat = (TS_WAITING | TS_WAIT_SLP);
		make_wait();
		LOG_TSKSTAT(my_p_runtsk);
		RELEASE_TSK_LOCK(my_p_pcb);
		dispatch();
		ercd = my_p_runtsk->wercd;
	}
	t_unlock_cpu();

  error_exit:
	LOG_SLP_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_slp_tsk */

/*
 *  ԤʥॢȤ
 */
#ifdef TOPPERS_tslp_tsk

ER
tslp_tsk(TMO tmout)
{
	ER		ercd;

	LOG_TSLP_TSK_ENTER(tmout);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_RUNNABLE();
	if (my_p_runtsk->wupque) {
		my_p_runtsk->wupque = false;
		RELEASE_TSK_LOCK(my_p_pcb);
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		RELEASE_TSK_LOCK(my_p_pcb);
		ercd = E_TMOUT;
	}
	else {
		my_p_runtsk->tstat = (TS_WAITING | TS_WAIT_SLP);
		make_wait_tmout(tmout);
		LOG_TSKSTAT(my_p_runtsk);
		RELEASE_TSK_LOCK(my_p_pcb);
		dispatch();
		ercd = my_p_runtsk->wercd;
	}
	t_unlock_cpu();

  error_exit:
	LOG_TSLP_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_tslp_tsk */

/*
 *  ε
 */
#ifdef TOPPERS_wup_tsk

ER
wup_tsk(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;
	bool_t	dspreq = false;

	LOG_WUP_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	p_tcb = get_tcb_self(tskid);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (TSTAT_DORMANT(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else if (TSTAT_WAIT_SLP(p_tcb->tstat)) {
		if (wait_complete(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		ercd = E_OK;
	}
	else if (!(p_tcb->wupque)) {
		p_tcb->wupque = true;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	T_RELEASE_TSK_LOCK_AND_DISPATCH(p_tcb->p_pcb, dspreq);

  error_exit:
	LOG_WUP_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_wup_tsk */

/*
 *  ε󥿥ƥѡ
 */
#ifdef TOPPERS_iwup_tsk

ER
iwup_tsk(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;

	LOG_IWUP_TSK_ENTER(tskid);
	CHECK_INTCTX_UNL();
	CHECK_TSKID(tskid);
	p_tcb = get_tcb(tskid);

  retry:
	I_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (TSTAT_DORMANT(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else if (TSTAT_WAIT_SLP(p_tcb->tstat)) {
		if (wait_complete(p_tcb)) {
			if (dispatch_request(p_tcb->p_pcb)) {
				my_reqflg = true;
			}
		}
		ercd = E_OK;
	}
	else if (!(p_tcb->wupque)) {
		p_tcb->wupque = true;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	I_RELEASE_TSK_LOCK(p_tcb->p_pcb);

  error_exit:
	LOG_IWUP_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_iwup_tsk */

/*
 *  ׵Υ󥻥
 */
#ifdef TOPPERS_can_wup

ER_UINT
can_wup(ID tskid)
{
	TCB		*p_tcb;
	ER_UINT	ercd;

	LOG_CAN_WUP_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	p_tcb = get_tcb_self(tskid);

  retry:
	I_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (TSTAT_DORMANT(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
		ercd = p_tcb->wupque ? 1 : 0;
		p_tcb->wupque = false;
	}
	T_RELEASE_TSK_LOCK(p_tcb->p_pcb);

  error_exit:
	LOG_CAN_WUP_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_can_wup */

/*
 *  Ԥ֤ζ
 */
#ifdef TOPPERS_rel_wai

ER
rel_wai(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;
	bool_t	dspreq = false;

	LOG_REL_WAI_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID(tskid);
	p_tcb = get_tcb(tskid);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (!TSTAT_WAITING(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
#if TTYPE_KLOCK == G_KLOCK
		if (wait_release(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
#else /* TTYPE_KLOCK != G_KLOCK */
		if (!TSTAT_WAIT_WOBJ(p_tcb->tstat)) {
			/* ֥ԤǤʤ */
			dspreq = wait_release(p_tcb);
		}
		else {
			/*
			 * ֥Ԥξ
			 * ǥåɥåΤᡤåľ 
			 */
			WOBJCB *p_wobjcb = p_tcb->p_wobjcb;
			p_tcb->pend_relwai = true;
			RELEASE_TSK_LOCK(p_tcb->p_pcb);

			/*
			 * 餿
			 *   ֥ȥå -> å
			 * νǥå 
			 */
			if (ACQUIRE_OBJ_LOCK(p_wobjcb)) {
				t_unlock_cpu();
				goto retry;
			}
			T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_wobjcb);

			/* ξ֤ѲƤʤå */
			if (!(p_tcb->pend_relwai)) {
				/* ¾βսԤʤ줿 */
				T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
				T_RELEASE_OBJ_LOCK(p_wobjcb);
				ercd = E_OBJ;
				goto error_exit;
			}
			p_tcb->pend_relwai = false;
			dspreq = wait_release(p_tcb);
			RELEASE_OBJ_LOCK(p_wobjcb);
		}
		if (dspreq) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
#endif /* TTYPE_KLOCK != G_KLOCK */
		ercd = E_OK;
	}
	T_RELEASE_TSK_LOCK_AND_DISPATCH(p_tcb->p_pcb, dspreq);

  error_exit:
	LOG_REL_WAI_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_rel_wai */

/*
 *  Ԥ֤ζ󥿥ƥѡ
 */
#ifdef TOPPERS_irel_wai

ER
irel_wai(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;
	bool_t	dspreq = false;

	LOG_IREL_WAI_ENTER(tskid);
	CHECK_INTCTX_UNL();
	CHECK_TSKID(tskid);
	p_tcb = get_tcb(tskid);

  retry:
	I_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (!TSTAT_WAITING(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
#if TTYPE_KLOCK == G_KLOCK
		dspreq = wait_release(p_tcb);
#else /* TTYPE_KLOCK != G_KLOCK */
		if (!TSTAT_WAIT_WOBJ(p_tcb->tstat)) {
			/* ֥ԤǤʤ */
			dspreq = wait_release(p_tcb);
		}
		else {
			/*
			 * ֥Ԥξ
			 * ǥåɥåΤᡤåľ 
			 */
			WOBJCB *p_wobjcb = p_tcb->p_wobjcb;
			p_tcb->pend_relwai = true;
			RELEASE_TSK_LOCK(p_tcb->p_pcb);
			/*
			 * 餿
			 *   ֥ȥå -> å
			 * νǥå 
			 */
			if (ACQUIRE_OBJ_LOCK(p_wobjcb)) {
				t_unlock_cpu();
				goto retry;
			}
			I_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_wobjcb);

			/* ξ֤ѲƤʤå */
			if (!(p_tcb->pend_relwai)) {
				/* ¾βսԤʤ줿 */
				I_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
				I_RELEASE_OBJ_LOCK(p_wobjcb);
				ercd = E_OBJ;
				goto error_exit;
			}
			p_tcb->pend_relwai = false;
			dspreq = wait_release(p_tcb);
			RELEASE_OBJ_LOCK(p_wobjcb);
		}
		if (dspreq) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
#endif /* TTYPE_KLOCK != G_KLOCK */
		if (dspreq){
			if (dispatch_request(p_tcb->p_pcb)) {
				my_reqflg = true;
			}
		}
		ercd = E_OK;
	}
	I_RELEASE_TSK_LOCK(p_tcb->p_pcb);


  error_exit:
	LOG_IREL_WAI_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_irel_wai */

/*
 *  Ԥ֤ؤΰܹ
 * 
 *  оݤǤʤΥץåǥѥåػǤ
 *  ȯԤ롥  
 */
#ifdef TOPPERS_sus_tsk

ER
sus_tsk(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;
	bool_t	dspreq = false;

	LOG_SUS_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	p_tcb = get_tcb_self(tskid);

  retry:
	if (p_tcb == my_p_runtsk) {
		T_ACQUIRE_TSK_LOCK_AND_CHECK_RUNNABLE();
	}
	else {
		T_ACQUIRE_TSK_LOCK(p_tcb->p_pcb);
	}
	if (p_tcb == my_p_runtsk && !my_dspflg) {
		/* ʬǥѥåػ߾֤sus_tskȯԤȥ顼 */
		ercd = E_CTX;
	}
	else if (TSTAT_DORMANT(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else if (TSTAT_RUNNABLE(p_tcb->tstat)) {
		/*
		 *  ¹ԤǤ֤鶯Ԥ֤ؤ
		 */
		p_tcb->tstat = TS_SUSPENDED;
		LOG_TSKSTAT(p_tcb);
		if (make_non_runnable(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		ercd = E_OK;
	}
	else if (TSTAT_SUSPENDED(p_tcb->tstat)) {
		ercd = E_QOVR;
	}
	else {
		/*
		 *  Ԥ֤Ԥ֤ؤ
		 */
		p_tcb->tstat |= TS_SUSPENDED;
		LOG_TSKSTAT(p_tcb);
		ercd = E_OK;
	}
	T_RELEASE_TSK_LOCK_AND_DISPATCH(p_tcb->p_pcb, dspreq);

  error_exit:
	LOG_SUS_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_sus_tsk */

/*
 *  Ԥ֤κƳ
 */
#ifdef TOPPERS_rsm_tsk

ER
rsm_tsk(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;
	bool_t	dspreq = false;

	LOG_RSM_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID(tskid);
	p_tcb = get_tcb(tskid);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (!TSTAT_SUSPENDED(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else if (!TSTAT_WAITING(p_tcb->tstat)) {
		/*
		 *  Ԥ֤¹ԤǤ֤ؤ
		 */
		p_tcb->tstat = TS_RUNNABLE;
		LOG_TSKSTAT(p_tcb);
		if (make_runnable(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		ercd = E_OK;
	}
	else {
		/*
		 *  Ԥ֤Ԥ֤ؤ
		 */
		p_tcb->tstat &= ~TS_SUSPENDED;
		LOG_TSKSTAT(p_tcb);
		ercd = E_OK;
	}
	T_RELEASE_TSK_LOCK_AND_DISPATCH(p_tcb->p_pcb, dspreq);

  error_exit:
	LOG_RSM_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_rsm_tsk */

/*
 *  ٱ
 */
#ifdef TOPPERS_dly_tsk

ER
dly_tsk(RELTIM dlytim)
{
	ER		ercd;

	LOG_DLY_TSK_ENTER(dlytim);
	CHECK_DISPATCH();
	CHECK_PAR(dlytim <= TMAX_RELTIM);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_RUNNABLE();
	my_p_runtsk->tstat = (TS_WAITING | TS_WAIT_DLY);
	(void) make_non_runnable(my_p_runtsk);
	tmevtb_enqueue(my_p_tevtcb, &(my_p_runtsk->tmevtb), dlytim, (CBACK) wait_tmout_ok, (void *) my_p_runtsk);
	LOG_TSKSTAT(my_p_runtsk);
	RELEASE_TSK_LOCK(my_p_pcb);
	dispatch();
	ercd = my_p_runtsk->wercd;
	t_unlock_cpu();

  error_exit:
	LOG_DLY_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_dly_tsk */
