/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: time_event.c 241 2009-04-30 04:51:39Z ertl-honda $
 */

/*
 *		।٥ȴ⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "time_event.h"
#include "task.h"
#include "mp.h"

/*
 *  ।٥ȥҡޥ
 */
#define	PARENT(index)		((index) >> 1)		/* ƥΡɤ */
#define	LCHILD(index)		((index) << 1)		/* λҥΡɤ */
#define	TMEVT_NODE(p_tevtcb, index)	((p_tevtcb->p_tmevt_heap)[(index) - 1])

/*
 *  ٥ȯӥޥ
 *
 *  ٥ȯϡcurrent_timeͤӤ롥ʤ
 *  current_timeǾ͡ʺǤᤤˡcurrent_time-1͡ʺǤ
 *  󤤻ˤȤߤʤӤ롥
 */
#define	EVTTIM_LT(p_tevtcb, t1, t2) (((t1) - p_tevtcb->current_time) < ((t2) - p_tevtcb->current_time))
#define	EVTTIM_LE(p_tevtcb, t1, t2) (((t1) - p_tevtcb->current_time) <= ((t2) - p_tevtcb->current_time))

#ifdef TOPPERS_tmeini

/*
 *  ޥ⥸塼ν
 */
void
initialize_tmevt(void)
{
	my_current_time = 0U;
	my_next_time = my_current_time + TIC_NUME / TIC_DENO;
#if TIC_DENO != 1U
	my_next_subtime = TIC_NUME % TIC_DENO;
#endif /* TIC_DENO != 1U */
	my_last_index = 0U;
#ifdef TOPPERS_SUPPORT_GET_UTM
	my_pend_update = false;
#endif /* TOPPERS_SUPPORT_GET_UTM */

	/*
	 *  Х륿ξϾĹϤʤ
	 */
	my_p_tmevt_heap = my_tmevt_heap;

	my_p_pcb->p_tevtcb = my_p_tevtcb;
}

#endif /* TOPPERS_tmeini */

/*
 *  ।٥Ȥ֤õ
 *
 *  timeȯ륿।٥ȤΡɤ뤿ˡ
 *  ҡפξ˸äƶΡɤư롥ưζΡɤΰ֤
 *  indexϤȡưζΡɤΰ֡ʤʤ֡ˤ֤
 */
#ifdef TOPPERS_tmeup

uint_t
tmevt_up(TEVTCB *p_tevtcb, uint_t index, EVTTIM time)
{
	uint_t	parent;

	while (index > 1) {
		/*
		 *  ƥΡɤΥ٥ȯᤤʤޤƱ
		 *  ʤСindex ֤ʤΤǥ롼פȴ롥
		 */
		parent = PARENT(index);
		if (EVTTIM_LE(p_tevtcb, TMEVT_NODE(p_tevtcb, parent).time, time)) {
			break;
		}

		/*
		 *  ƥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(p_tevtcb, index) = TMEVT_NODE(p_tevtcb, parent);
		TMEVT_NODE(p_tevtcb, index).p_tmevtb->index = index;

		/*
		 *  index ƥΡɤΰ֤˹
		 */
		index = parent;
	}
	return(index);
}

#endif /* TOPPERS_tmeup */

/*
 *  ।٥Ȥ֤򲼸õ
 *
 *  timeȯ륿।٥ȤΡɤ뤿ˡ
 *  ҡפβ˸äƶΡɤư롥ưζΡɤΰ֤ 
 *  indexϤȡưζΡɤΰ֡ʤʤ֡ˤ֤
 */
#ifdef TOPPERS_tmedown

uint_t
tmevt_down(TEVTCB *p_tevtcb, uint_t index, EVTTIM time)
{
	uint_t	child;

	while ((child = LCHILD(index)) <= p_tevtcb->last_index) {
		/*
		 *  λҥΡɤΥ٥ȯӤᤤ
		 *  ҥΡɤΰ֤ child ꤹ롥ʲλҥΡ
		 *  ϡФ줿λҥΡɤΤȡ
		 */
		if (child + 1 <= p_tevtcb->last_index
						&& EVTTIM_LT(p_tevtcb,
									 TMEVT_NODE(p_tevtcb, child + 1).time,
									 TMEVT_NODE(p_tevtcb, child).time)) {
			child = child + 1;
		}

		/*
		 *  ҥΡɤΥ٥ȯ٤ʤޤƱ
		 *  ʤСindex ֤ʤΤǥ롼פȴ롥
		 */
		if (EVTTIM_LE(p_tevtcb, time, TMEVT_NODE(p_tevtcb, child).time)) {
			break;
		}

		/*
		 *  ҥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(p_tevtcb, index) = TMEVT_NODE(p_tevtcb, child);
		TMEVT_NODE(p_tevtcb, index).p_tmevtb->index = index;

		/*
		 *  index ҥΡɤΰ֤˹
		 */
		index = child;
	}
	return(index);
}

#endif /* TOPPERS_tmedown */

/*
 *  ।٥ȥҡפؤϿ
 *
 *  p_tmevtbǻꤷ।٥ȥ֥åtimeǻꤷ֤
 *  ˥٥Ȥȯ褦ˡ।٥ȥҡפϿ롥
 */
#ifdef TOPPERS_tmeins

void
tmevtb_insert(TEVTCB *p_tevtcb, TMEVTB *p_tmevtb, EVTTIM time)
{
	uint_t	index;

	/*
	 *  last_index 򥤥󥯥Ȥ֤õ
	 */
	index = tmevt_up(p_tevtcb, ++(p_tevtcb->last_index), time);

	/*
	 *  ।٥Ȥ index ΰ֤롥
	 */ 
	TMEVT_NODE(p_tevtcb, index).time = time;
	TMEVT_NODE(p_tevtcb, index).p_tmevtb = p_tmevtb;
	p_tmevtb->index = index;
}

#endif /* TOPPERS_tmeins */

/*
 *  ।٥ȥҡפκ
 */
#ifdef TOPPERS_tmedel

EVTTIM
tmevtb_delete(TEVTCB *p_tevtcb, TMEVTB *p_tmevtb)
{
	uint_t	index = p_tmevtb->index;
	uint_t	parent;
	EVTTIM	event_time = TMEVT_NODE(p_tevtcb, p_tevtcb->last_index).time;
	EVTTIM	re_event_time = TMEVT_NODE(p_tevtcb, p_tmevtb->index).time;

	/*
	 *  ˤ꥿।٥ȥҡפˤʤϲ⤷ʤ
	 */
	if (--(p_tevtcb->last_index) == 0) {
		return re_event_time;
	}

	/*
	 *  Ρɤΰ֤˺ǸΥΡɡlast_index+1ΰ֤ΥΡɡ
	 *  Ŭڤʰ֤ذư롥ºݤˤϡǸΥΡ
	 *  ºݤΤǤϤʤΡɤΰ֤Ρɤˤ
	 *  ΤǡǸΥΡɤ٤֤ظƶΡɤư
	 *  롥
	 *  ǸΥΡɤΥ٥ȯ郎ΡɤοƥΡɤΥ
	 *  ٥ȯξˤϡ˸ä֤õ
	 *  Ǥʤˤϡ˸äõ
	 */
	if (index > 1 && EVTTIM_LT(p_tevtcb, event_time,
								TMEVT_NODE(p_tevtcb, parent = PARENT(index)).time)) {
		/*
		 *  ƥΡɤindexΰ֤˰ư롥
		 */
		TMEVT_NODE(p_tevtcb, index) = TMEVT_NODE(p_tevtcb, parent);
		TMEVT_NODE(p_tevtcb, index).p_tmevtb->index = index;

		/*
		 *  ΡɤοƥΡɤ˸ä֤õ
		 */
		index = tmevt_up(p_tevtcb, parent, event_time);
	}
	else {
		/*
		 *  Ρɤ鲼˸ä֤õ
		 */
		index = tmevt_down(p_tevtcb, index, event_time);
	}

	/*
	 *  ǸΥΡɤindexΰ֤롥
	 */ 
	TMEVT_NODE(p_tevtcb, index) = TMEVT_NODE(p_tevtcb, (p_tevtcb->last_index) + 1);
	TMEVT_NODE(p_tevtcb, index).p_tmevtb->index = index;

	return re_event_time;
}

#endif /* TOPPERS_tmedel */

/*
 *  ।٥ȥҡפƬΥΡɤκ
 */
Inline void
tmevtb_delete_top(void)
{
	uint_t	index;
	EVTTIM	event_time = TMEVT_NODE(my_p_tevtcb, my_p_tevtcb->last_index).time;

	/*
	 *  ˤ꥿।٥ȥҡפˤʤϲ⤷ʤ
	 */
	if (--(my_last_index) == 0) {
		return;
	}

	/*
	 *  롼ȥΡɤ˺ǸΥΡɡlast_index + 1 ΰ֤ΥΡɡˤ
	 *  Ŭڤʰ֤ذư롥ºݤˤϡǸΥΡɤ
	 *  ºݤΤǤϤʤ롼ȥΡɤΡɤˤʤΤǡ
	 *  ΥΡɤ٤֤ظƶΡɤư롥
	 */
	index = tmevt_down(my_p_tevtcb, 1, event_time);

	/*
	 *  ǸΥΡɤindexΰ֤롥
	 */ 
	TMEVT_NODE(my_p_tevtcb, index) = TMEVT_NODE(my_p_tevtcb, my_last_index + 1);
	TMEVT_NODE(my_p_tevtcb, index).p_tmevtb->index = index;
}

/*
 *  ।٥ȤޤǤλĤ֤η׻
 */
#ifdef TOPPERS_tmeltim

RELTIM
tmevt_lefttim(TEVTCB *p_tevtcb, TMEVTB *p_tmevtb)
{
	EVTTIM	time;

	time = TMEVT_NODE(p_tevtcb, p_tmevtb->index).time;
	if (EVTTIM_LE(p_tevtcb, time, p_tevtcb->next_time)) {
		/*
		 *  Υƥåǽˤ0֤
		 */
		return(0U);
	}
	else {
		return((RELTIM)(time - base_time(p_tevtcb)));
	}
}

#endif /* TOPPERS_tmeltim */

/*
 *  ƥåζ
 */
#ifdef TOPPERS_sigtim

void
signal_time(void)
{
	TMEVTB	*p_tmevtb;

#ifdef TOPPERS_SUPPORT_GET_UTM
	my_pend_update = true;
#endif /* TOPPERS_SUPPORT_GET_UTM */
	assert(sense_context());
	assert(!i_sense_lock());

  retry:
	I_ACQUIRE_TSK_LOCK(my_p_pcb);

	/*
	 *  next_timeꥤ٥ȯᤤʤޤƱ˥।٥
	 *  Ȥ򡤥।٥ȥҡפХåؿƤӽ
	 *  
	 */
	while ((my_last_index) > 0 && EVTTIM_LE(my_p_tevtcb, TMEVT_NODE(my_p_tevtcb, 1).time, my_next_time)) {
		p_tmevtb = TMEVT_NODE(my_p_tevtcb, 1).p_tmevtb;
		tmevtb_delete_top();
		(*(p_tmevtb->callback))(p_tmevtb->arg);
	}

	/*
	 *  current_time򹹿롥
	 */
	my_current_time = my_next_time;
#ifdef TOPPERS_SUPPORT_GET_UTM
	my_pend_update = false;
#endif /* TOPPERS_SUPPORT_GET_UTM */

	/*
	 *  next_timenext_subtime򹹿롥
	 *
	 *  TIC_NUME < TIC_DENOλϡȤ鷺˻ιǤ뤬
	 *  ɤɤߤ䤹ˤ뤿#if¿Ѥ򤱤Ƥ롥
	 */
#if TIC_DENO == 1U
	my_next_time = my_current_time + TIC_NUME;
#else /* TIC_DENO == 1U */
	my_next_subtime += TIC_NUME % TIC_DENO;
	my_next_time = my_current_time + TIC_NUME / TIC_DENO;
	if (my_next_subtime >= TIC_DENO) {
		my_next_subtime -= TIC_DENO;
		my_next_time += 1U;
	}
#endif /* TIC_DENO == 1U */

	I_RELEASE_TSK_LOCK(my_p_pcb);
}

#endif /* TOPPERS_sigtim */


#ifdef TOPPERS_get_my_current_time

/*
 *  syslogǻѤ뤿
 */
ulong_t
get_my_current_time(void){
	return my_current_time;
}

#endif /* TOPPERS_get_my_current_time */
