/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: perf_act_tsk.c 170 2009-02-25 08:27:36Z ertl-kikuchi $
 */

#include <kernel.h>
#include <t_syslog.h>
#include <sil.h>
#include <histogram.h>
#include "kernel_cfg.h"
#include "perf_act_tsk.h"
#include "target_test.h"

/*
 *  ¬ȼ¹ԻʬۤϿ
 */
#define NO_MEASURE	20000U			/* ¬ */
#define MAX_TIME	400000U			/* ¹ԻʬۤϿ */

/*
 *  ¹ԻʬۤϿΰ
 */
static uint_t	histarea1[MAX_TIME + 1];

/*
 *  ¬ǤΥեå롼
 */
#ifndef CPU1_PERF_PRE_HOOK
#define CPU1_PERF_PRE_HOOK
#endif  /* CPU1_PERF_PRE_HOOK */
#ifndef CPU1_PERF_POST_HOOK
#define CPU1_PERF_POST_HOOK
#endif  /* CPU1_PERF_POST_HOOK */
#ifndef CPU2_PERF_PRE_HOOK
#define CPU2_PERF_PRE_HOOK
#endif  /* CPU2_PERF_PRE_HOOK */
#ifndef CPU2_PERF_POST_HOOK
#define CPU2_PERF_POST_HOOK
#endif  /* CPU2_PERF_POST_HOOK */

void task1_1(intptr_t exinf)
{
	end_measure(1);
}


void task1_2(intptr_t exinf)
{
	;
}


void task1_3(intptr_t exinf)
{
	slp_tsk();
}


void task2_1(intptr_t exinf)
{
	end_measure(1);
}


void task2_2(intptr_t exinf)
{
	for ( ; ; )
	{
		BUSY_WAIT(10000);
	}
}


void task2_3(intptr_t exinf)
{
	end_measure(1);
	ter_tsk(TASK2_2);
}

/*
 * ¬롼
 */
void perf_eval(uint_t n)
{
	uint_t	i;

	init_hist(1, MAX_TIME, histarea1);

	sus_tsk(LOGTASK1);
	dly_tsk(1000);
	CPU1_PERF_PRE_HOOK;

	for ( i = 0; i < NO_MEASURE; i++ ) {
		switch (n) {
			//Сإåɤ¬
		case 0:
			begin_measure(1);
			end_measure(1);
			break;
			//ڣۼCPUǺǹͥ٤
		case 1:
			begin_measure(1);
			act_tsk(TASK1_1);
			break;
			//ڣۥǥ塼¾CPUǵư
		case 2:
			STAT_WAIT(TASK2_1, TTS_DMT);
			begin_measure(1);
			act_tsk(TASK2_1);
			break;
			//ڣ¾CPUǵưǹͥ٤
		case 3:
			STAT_WAIT(TASK2_3, TTS_DMT);
			STAT_WAIT(TASK2_2, TTS_DMT);
			act_tsk(TASK2_2);
			STAT_WAIT(TASK2_2, TTS_RDY);
			begin_measure(1);
			act_tsk(TASK2_3);
			break;
			//ڣۼCPUǵư¹Բǽ֤
		case 4:
			begin_measure(1);
			act_tsk(TASK1_2);
			end_measure(1);
			ter_tsk(TASK1_2);
			break;
			//ڣۼCPUǵư뤬ԤΤᥭ塼󥰿򥤥󥯥
		case 5:
			act_tsk(TASK1_3);
			begin_measure(1);
			act_tsk(TASK1_3);
			end_measure(1);
			wup_tsk(TASK1_3);
			wup_tsk(TASK1_3);
			break;
		}
	}

	CPU1_PERF_POST_HOOK;
	rsm_tsk(LOGTASK1);

	syslog(LOG_NOTICE, "==================================");
	syslog(LOG_NOTICE, "(%d)", n);
	syslog(LOG_NOTICE, "----------------------------------");
	print_hist(1);
}

/*
 *  PE1 ᥤ󥿥ͥ
 */
void main_task1(intptr_t exinf)
{
	slp_tsk();
	perf_eval(0);
	perf_eval(1);
	perf_eval(2);
	perf_eval(3);
	perf_eval(4);
	perf_eval(5);
	wup_tsk(MAIN_TASK2);
}

/*
 *  PE2 ᥤ󥿥ͥ
 */
void main_task2(intptr_t exinf)
{
	sus_tsk(LOGTASK2);
	CPU2_PERF_PRE_HOOK;
	wup_tsk(MAIN_TASK1);
	slp_tsk();
	CPU2_PERF_POST_HOOK;
	rsm_tsk(LOGTASK2);
}
