/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2008-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 117 2009-01-29 17:21:26Z ertl-honda $
 */

/*
 * åװ¸⥸塼NIOS2_DEVѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "jtag_uart.h"
#include "mp.h"

/*
 *  target_fput_log() ѤUARTΥ١ɥ쥹
 */
const uint32_t target_fput_log_base_table[TNUM_PRC] = {
	JTAG_UART_1_BASE,
#if TNUM_PRC >= 2
	JTAG_UART_2_BASE,
#endif /* TNUM_PRC >= 2 */
#if TNUM_PRC >= 3
	JTAG_UART_3_BASE,
#endif /* TNUM_PRC >= 3 */
#if TNUM_PRC >= 4
	JTAG_UART_4_BASE,
#endif /* TNUM_PRC >= 4 */
};

/*
 *  ץåֳHWΥ١ɥ쥹
 */
const uint32_t target_prc_int_base_table[TNUM_PRC] = {
	PRC_INT_1_BASE,
#if TNUM_PRC >= 2
	PRC_INT_2_BASE,
#endif /* TNUM_PRC >= 2 */
#if TNUM_PRC >= 3
	PRC_INT_3_BASE,
#endif /* TNUM_PRC >= 3 */
#if TNUM_PRC >= 4
	PRC_INT_4_BASE,
#endif /* TNUM_PRC >= 4 */
};

/*
 *  åΥơ֥
 */
const uint32_t target_tsk_lock_table[TNUM_PRC] = {
	TSK_MUTEX_1_BASE,
#if TNUM_PRC >= 2
	TSK_MUTEX_2_BASE,
#endif /* TNUM_PRC >= 2 */
#if TNUM_PRC >= 3
	TSK_MUTEX_3_BASE,
#endif /* TNUM_PRC >= 3 */
#if TNUM_PRC >= 4
	TSK_MUTEX_4_BASE,
#endif /* TNUM_PRC >= 4 */
};

/*
 *  ֥ȥåΥơ֥
 */
const uint32_t target_obj_lock_table[TNUM_PRC] = {
	OBJ_MUTEX_1_BASE,
#if TNUM_PRC >= 2
	OBJ_MUTEX_2_BASE,
#endif /* TNUM_PRC >= 2 */
#if TNUM_PRC >= 3
	OBJ_MUTEX_3_BASE,
#endif /* TNUM_PRC >= 3 */
#if TNUM_PRC >= 4
	OBJ_MUTEX_4_BASE,
#endif /* TNUM_PRC >= 4 */
};

/*
 *  str_ker() ǥޥץåǹԤ
 */
void
target_mprc_initialize(void)
{

}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{   
	/*
	 *  Nios2¸ν
	 */
	prc_initialize();
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *  Nios2¸νλ
	 */
	prc_terminate();

	while(1);
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char_t c)
{
	uint32_t base = target_fput_log_base_table[x_prc_index()];

	if (c == '\n') {
		jtag_uart_putc(base, '\r');
	}
	jtag_uart_putc(base, c);
}
